//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property   strict
const int g_intesivity = 1000000000;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CTester
  {
public:
                     CTester() {val = 1;}
   ulong              getVal() {return val;}
protected:
   ulong              val;
  };
//+------------------------------------------------------------------+
//+ rand() is used to cheat compiler optimisations
//+------------------------------------------------------------------+
void OnStart()
  {
   Print("--------------");


//-direct access test:

   CTester t1();
   ulong timer1 = GetTickCount();

   srand(1); //-reset random generator to get always same sequence
   ulong result = 0;
   for(int i = 0; i < g_intesivity; i++)
     {
      result += t1.getVal() + rand();
     }

   timer1 = GetTickCount() - timer1;
   Print("direct access: ", timer1, " ms");


//-reference access test:

   CTester t2();
   srand(1); //-reset random generator to get always same sequence
   ulong timer2 = GetTickCount();
   const ulong res2 = IntenseMemberAccess(t2, g_intesivity);
   timer2 = GetTickCount() - timer2;
   Print("access by reference: ", timer2, " ms");


//-pointer access test:

   CTester *t3 = GetPointer(t2);
   ulong timer3 = GetTickCount();
   const ulong res3 = IntenseMemberAccess(t3, g_intesivity);
   timer3 = GetTickCount() - timer3;
   Print("access by pointer: ", timer3, " ms");

//-pointer access test optimized:

   CTester *t4 = new CTester();
   ulong timer4 = GetTickCount();
   const ulong res4 = IntenseMemberAccessOpt(t4, g_intesivity);
   timer4 = GetTickCount() - timer4;
   Print("access by pointer optimized: ", timer4, " ms");

//-final results:

   if(res2 != res3 || result != res2 || res4!=res2)
     {
      Print("something went wrong:", res2, " ", res3);
     }
   else
     {
      Print("access by reference is ~", DoubleToString((double)timer3 / timer2, 2), " times faster than access by pointer");
     }
  delete t4;
  }
//+------------------------------------------------------------------+
ulong IntenseMemberAccess(CTester &some_obj, const int intesivity)
  {
   srand(1); //-reset random generator to get always same sequence

   ulong result = 0;
   for(int i = 0; i < intesivity; i++)
     {
      result += some_obj.getVal() + rand();
     }
   return result;
  }
//+------------------------------------------------------------------+
ulong IntenseMemberAccess(CTester *some_obj, const int intesivity)
  {
   srand(1); //-reset random generator to get always same sequence

   ulong result = 0;
   for(int i = 0; i < intesivity; i++)
     {
      result += some_obj.getVal() + rand();
     }
   return result;
  }
//+------------------------------------------------------------------+
ulong IntenseMemberAccessOpt(CTester *some_obj, const int intesivity)
  {
   srand(1); //-reset random generator to get always same sequence

   ulong value  = some_obj.getVal();
   ulong result = 0;
   for(int i = 0; i < intesivity; i++)
     {
      result += value + rand();
     }
   return result;
  }
//+------------------------------------------------------------------+
